import { findNodeHandle } from 'react-native';
/** wrapper func for setState that returns a promise */
// eslint-disable-next-line consistent-this

export function setStateAsync(that, newState) {
  return new Promise(resolve => {
    that.setState(newState, () => {
      resolve();
    });
  });
}
;
/** wrapper for timeout that returns a promise */

export function timeout(ms) {
  return new Promise(resolve => {
    const timeoutID = setTimeout(() => {
      clearTimeout(timeoutID);
      resolve();
    }, ms);
  });
}
;
/** Wraps a promise that will reject if not not resolved in <ms> milliseconds */

export function promiseWithTimeout(ms, promise) {
  // Create a promise that rejects in <ms> milliseconds
  const timeoutPromise = new Promise((_, reject) => {
    const timeoutID = setTimeout(() => {
      clearTimeout(timeoutID);
      reject(`Promise timed out in ${ms} ms.`);
    }, ms);
  }); // Returns a race between our timeout and the passed in promise

  return Promise.race([promise, timeoutPromise]);
}
;
export function pad(num) {
  let places = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;
  return String(num).padStart(places, '0');
}
;
export function getNativeNodeHandle(nativeRef) {
  const nodeHandle = findNodeHandle(nativeRef);

  if (nodeHandle === null) {
    throw new Error('Unable to get the node handle for the native ref.');
  }

  ;
  return nodeHandle;
}
;
//# sourceMappingURL=Helpers.js.map