function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { requireNativeComponent } from 'react-native';
import { RNIWrapperViewModule } from '../native_modules/RNIWrapperViewModule';
import * as Helpers from '../functions/Helpers';
const COMPONENT_NAME = 'RNIWrapperView';
const NativeComponent = requireNativeComponent(COMPONENT_NAME);
export class RNIWrapperView extends React.PureComponent {
  constructor(props) {
    var _this;

    super(props);
    _this = this;

    _defineProperty(this, "nativeRef", void 0);

    _defineProperty(this, "_handleNativeRef", ref => {
      this.nativeRef = ref;
    });

    _defineProperty(this, "notifyComponentWillUnmount", function () {
      let isManuallyTriggered = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      RNIWrapperViewModule.notifyComponentWillUnmount(Helpers.getNativeNodeHandle(_this.nativeRef), {
        isManuallyTriggered
      });
    });
  }

  componentWillUnmount() {
    var _this$props$shouldNot;

    const shouldNotifyComponentWillUnmount = (_this$props$shouldNot = this.props.shouldNotifyComponentWillUnmount) !== null && _this$props$shouldNot !== void 0 ? _this$props$shouldNot : false;

    if (shouldNotifyComponentWillUnmount) {
      this.notifyComponentWillUnmount(false);
    }

    ;
  }

  render() {
    var _props$shouldNotifyCo;

    const props = this.props;
    return /*#__PURE__*/React.createElement(NativeComponent, { ...props,
      ref: this._handleNativeRef,
      shouldNotifyComponentWillUnmount: (_props$shouldNotifyCo = props.shouldNotifyComponentWillUnmount) !== null && _props$shouldNotifyCo !== void 0 ? _props$shouldNotifyCo : false
    });
  }

}
;
//# sourceMappingURL=RNIWrapperView.js.map